
import 'isw_mobile_sdk_sdk_config.dart';

class IswPaymentResult {
  final String? responseCode;
  final String? responseDescription;
  final bool isSuccessful;
  final String? transactionReference;
  final int amount;
  final PaymentChannel channel;

  IswPaymentResult(this.responseCode, this.responseDescription,
      this.isSuccessful, this.transactionReference, this.amount, this.channel);

  static IswPaymentResult fromJson(Map<dynamic, dynamic> json) {
    final isSuccessful = json['isSuccessful'].toLowerCase() == 'true';

    final providedChannel = json['channel'].toLowerCase();
    PaymentChannel channel;
    if (providedChannel == nameOf(PaymentChannel.CARD)) {
      channel = PaymentChannel.CARD;
    } else if (providedChannel == nameOf(PaymentChannel.WALLET)) {
      channel = PaymentChannel.WALLET;
    } else if (providedChannel == nameOf(PaymentChannel.USSD)) {
      channel = PaymentChannel.USSD;
    } else if (providedChannel == nameOf(PaymentChannel.QR)) {
      channel = PaymentChannel.QR;
    } else {
      channel = PaymentChannel.PAYCODE;
    }

    return IswPaymentResult(
        json['responseCode'],
        json['responseDescription'],
        isSuccessful,
        json['transactionReference'],
        int.parse(json['amount']),
        channel);
  }

  static String nameOf(PaymentChannel channel) {
    final name = channel.toString().toLowerCase();
    return name.substring(name.indexOf('.') + 1);
  }
}


class Optional<T> {
  final T value;
  final bool hasValue;

  Optional(this.value, this.hasValue);
}